; ##############################################################################
; ##############################################################################
; ##############################################################################
TOUCH_INITIALISIERUNG:
	; auf EINGANG	
	cbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	cbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; PULL-UP AUS	
	cbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	cbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
;------------------------------------------------------------------------------
	; X auf AUSGANG		
	sbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	sbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	; X auf LOW / HIGH	
	sbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	; MESSUNG +KORREKTUR
	rcall MESSEN_1							; X (max)
	subi temp1,LOW (TOUCH_ADC_KORREKTUR_X_MAX * -1)
	sbci temp2,HIGH(TOUCH_ADC_KORREKTUR_X_MAX * -1)
	STS(adr_ADC_X_MAX_L),temp1
	STS(adr_ADC_X_MAX_H),temp2
	; MESSUNG +KORREKTUR
	rcall MESSEN_3							; X (min)
	subi temp1,LOW (TOUCH_ADC_KORREKTUR_X_MIN * -1)
	sbci temp2,HIGH(TOUCH_ADC_KORREKTUR_X_MIN * -1)
	STS(adr_ADC_X_MIN_L),temp1
	STS(adr_ADC_X_MIN_H),temp2
	; X auf EINGANG		
	cbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	; PULL-UP AUS		
	cbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
;------------------------------------------------------------------------------
	; Y auf AUSGANG		
	sbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	sbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; Y auf LOW / HIGH	
	sbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	; MESSUNG +KORREKTUR
	rcall MESSEN_0							; Y (max)
	subi temp1,LOW (TOUCH_ADC_KORREKTUR_Y_MAX * -1)
	sbci temp2,HIGH(TOUCH_ADC_KORREKTUR_Y_MAX * -1)
	STS(adr_ADC_Y_MAX_L),temp1
	STS(adr_ADC_Y_MAX_H),temp2
	; MESSUNG +KORREKTUR
	rcall MESSEN_2							; Y (min)
	subi temp1,LOW (TOUCH_ADC_KORREKTUR_Y_MIN * -1)
	sbci temp2,HIGH(TOUCH_ADC_KORREKTUR_Y_MIN * -1)
	STS(adr_ADC_Y_MIN_L),temp1
	STS(adr_ADC_Y_MIN_H),temp2
	; auf EINGANG	
	cbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; PULL-UP AUS	
	cbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; X auf GND																		
; Y auf EINGANG und PULL-UP ein													
TOUCH_STANDBY_MODUS:
	; X auf AUSGANG	
	sbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	sbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	; X auf LOW		
	cbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
;------------------------------------------------------------------------------
	; Y auf AUSGANG	
	sbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	sbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; Y auf HIGH	
	sbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	sbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	; Y auf EINGANG	/ PULL-UP ein	
	cbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TOUCH_MESSUNG:
;-------------------------------------------------------------------------------
; Entprellung beim Antippen des Touchs											
; mehrere ms muss der TOUCH gedrckt sein										
TOUCH_MESSUNG_ENTPRELLUNG_ANTIPPEN:
	ldi temp,(TOUCH_ENTPRELLZEIT_ANTIPPEN)	; ENTPRELLZEIT
TOUCH_MESSUNG_ENTPRELLUNG_ANTIPPEN_s:
	; ENTPRELLUNG Y+ muss permanent gegen GND gezogen werden
	sbis (TOUCH_YP_PIN),(TOUCH_YP_PIN_NR)	; PIN abfragen	
	rjmp TOUCH_MESSUNG_ENTPRELLUNG_ANTIPPEN_OK
	; Entprellung ERROR						
	ret
;-------------------------------------------------------------------------------
TOUCH_MESSUNG_ENTPRELLUNG_ANTIPPEN_OK:
	rcall wait_1ms
	dec temp
	brne TOUCH_MESSUNG_ENTPRELLUNG_ANTIPPEN_s
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; X-EXAKTMESSUNG																
; Bestromung von X																
; MESSUNG an Y																	
; PULL-UPs von Y aus, um Messfehler zu verringern								
TOUCH_MESSUNG_EXAKT:
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   
	; Y auf EINGANG			
	cbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; Y PULL-UP aus			
	cbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	; X auf AUSGANG			
	sbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	sbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	; X auf LOW	und HIGH	
	sbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	; ADC Y					
	rcall wait_1ms 							; kurze PAUSE
	rcall MESSEN_0
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; Y-EXAKTMESSUNG																
; Bestromung von Y																
; MESSUNG an X																	
; PULL-UPs von X aus, um Messfehler zu verringern								
	; X auf Eingang			
	cbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	; X PULL-UP aus			
	cbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	; Y auf AUGANG			
	sbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	sbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y-	
	; Y auf LOW	und HIGH	
	sbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	; ADC X					
	rcall wait_1ms 							; kurze PAUSE
	rcall MESSEN_1
;-------------------------------------------------------------------------------
; STANDBY-MODUS																	
	rcall TOUCH_STANDBY_MODUS
	; BERECHNUNG				
	rcall TOUCH_BERECHNUNG_KOORDINATEN_X
	rcall TOUCH_BERECHNUNG_KOORDINATEN_Y
	; BUFFER write				
	rcall BUFFER_DATA_WRITE
	; BEEP						
	rcall BEEP_TOUCH
	; TX-USART	(5 Bytes)		
	ldi temp1,'*'							; Vorspann		
	rcall SENDEN_TEMP1
	LDS temp1,(adr_TOUCH_KOORDINATE_X_L)	; X-Koordinaten	
	rcall SENDEN_TEMP1
	LDS temp1,(adr_TOUCH_KOORDINATE_X_H)
	rcall SENDEN_TEMP1
	LDS temp1,(adr_TOUCH_KOORDINATE_Y_L)	; Y-Koordinaten	
	rcall SENDEN_TEMP1
	LDS temp1,(adr_TOUCH_KOORDINATE_Y_H)
	rcall SENDEN_TEMP1
;-------------------------------------------------------------------------------
; Entprellung, bist TOUCH mehrere ms lang nicht mehr berhrt wird				
TOUCH_MESSUNG_ENTPRELLUNG_LOSLASSEN:
	ldi temp,(TOUCH_ENTPRELLZEIT_LOSLASSEN)	; ENTPRELLZEIT_LOSLASSEN
TOUCH_MESSUNG_ENTPRELLUNG__LOSLASSEN_s:
	rcall wait_1ms							; PAUSE					
	; LOOP, bis Y+ nicht gegen GND gezogen wird
	sbis (TOUCH_YP_PIN),(TOUCH_YP_PIN_NR)
	rjmp TOUCH_MESSUNG_ENTPRELLUNG_LOSLASSEN
	dec temp
	brne TOUCH_MESSUNG_ENTPRELLUNG__LOSLASSEN_s
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
;-------------------------------------------------------------------------------
; fr Wartungsarbeiten															
	rcall ANZEIGE_KOORDINATEN

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KOORDINATE=(PIXEL) x (ADC)-(MIN) / (MAX)-(MIN)
TOUCH_BERECHNUNG_KOORDINATEN_X:
;	; TESTZAHLEN				
;	ldi temp1,LOW (550)			; ADC 
;	ldi temp2,HIGH(550)
;	STS(adr_ADC_0_L),temp1
;	STS(adr_ADC_0_H),temp2
;	ldi temp1,LOW (200)			; MIN 
;	ldi temp2,HIGH(200)
;	STS(adr_ADC_X_MIN_L),temp1
;	STS(adr_ADC_X_MIN_H),temp2
;	ldi temp1,LOW (900)			; MAX 
;	ldi temp2,HIGH(900)
;	STS(adr_ADC_X_MAX_L),temp1
;	STS(adr_ADC_X_MAX_H),temp2

	; (ADC)-(MIN)				
	LDS temp1,(adr_ADC_0_L)
	LDS temp2,(adr_ADC_0_H)
	LDS temp3,(adr_ADC_X_MIN_L)
	LDS temp4,(adr_ADC_X_MIN_H)
	sub temp1,temp3
	sbc temp2,temp4
	; negativ ?					
	tst temp2
	brpl TOUCH_BERECHNUNG_KOORDINATEN_X_n
	; ERROR						
	clr temp1
	clr temp2
TOUCH_BERECHNUNG_KOORDINATEN_X_n:
	; (PIXEL) x Ergebnis		
	ldi temp3,LOW (DISPLAY_PIXEL_X)
	ldi temp4,HIGH(DISPLAY_PIXEL_X)
	rcall FUNKTION_MULTIPLIKATION_16_16_32
	; (MAX)-(MIN)				
	LDS temp5,(adr_ADC_X_MAX_L)
	LDS temp6,(adr_ADC_X_MAX_H)
	LDS temp7,(adr_ADC_X_MIN_L)
	LDS temp8,(adr_ADC_X_MIN_H)
	sub temp5,temp7
	sbc temp6,temp8
	rcall FUNCTION_DIVISION_32_16
	; Ergebnis grer als PIXEL ?	
	cpi temp2,HIGH(DISPLAY_PIXEL_X)	; HIGH
	breq TOUCH_BERECHNUNG_KOORDINATEN_X_L
	brsh TOUCH_BERECHNUNG_KOORDINATEN_X_ERROR
	brlo TOUCH_BERECHNUNG_KOORDINATEN_X_OK
TOUCH_BERECHNUNG_KOORDINATEN_X_L:
	cpi temp1,LOW (DISPLAY_PIXEL_X)	; LOW 
	breq TOUCH_BERECHNUNG_KOORDINATEN_X_OK
	brlo TOUCH_BERECHNUNG_KOORDINATEN_X_OK
TOUCH_BERECHNUNG_KOORDINATEN_X_ERROR:
	; ERROR						
	ldi temp1,LOW (DISPLAY_PIXEL_X)
	ldi temp2,HIGH(DISPLAY_PIXEL_X)
TOUCH_BERECHNUNG_KOORDINATEN_X_OK:
	; Ergebnis speichern		
	STS(adr_TOUCH_KOORDINATE_X_L),temp1
	STS(adr_TOUCH_KOORDINATE_X_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KOORDINATE=(PIXEL) x (ADC)-(MIN) / (MAX)-(MIN)
TOUCH_BERECHNUNG_KOORDINATEN_Y:
;	; TESTZAHLEN				
;	ldi temp1,LOW (550)			; ADC 
;	ldi temp2,HIGH(550)
;	STS(adr_ADC_1_L),temp1
;	STS(adr_ADC_1_H),temp2
;	ldi temp1,LOW (200)			; MIN 
;	ldi temp2,HIGH(200)
;	STS(adr_ADC_Y_MIN_L),temp1
;	STS(adr_ADC_Y_MIN_H),temp2
;	ldi temp1,LOW (900)			; MAX 
;	ldi temp2,HIGH(900)
;	STS(adr_ADC_Y_MAX_L),temp1
;	STS(adr_ADC_Y_MAX_H),temp2

	; (ADC)-(MIN)				
	LDS temp1,(adr_ADC_1_L)
	LDS temp2,(adr_ADC_1_H)
	LDS temp3,(adr_ADC_Y_MIN_L)
	LDS temp4,(adr_ADC_Y_MIN_H)
	sub temp1,temp3
	sbc temp2,temp4
	; negativ ?					
	tst temp2
	brpl TOUCH_BERECHNUNG_KOORDINATEN_Y_n
	; ERROR						
	clr temp1
	clr temp2
TOUCH_BERECHNUNG_KOORDINATEN_Y_n:
	; (PIXEL) x Ergebnis		
	ldi temp3,LOW (DISPLAY_PIXEL_Y)
	ldi temp4,HIGH(DISPLAY_PIXEL_Y)
	rcall FUNKTION_MULTIPLIKATION_16_16_32
	; (MAX)-(MIN)				
	LDS temp5,(adr_ADC_Y_MAX_L)
	LDS temp6,(adr_ADC_Y_MAX_H)
	LDS temp7,(adr_ADC_Y_MIN_L)
	LDS temp8,(adr_ADC_Y_MIN_H)
	sub temp5,temp7
	sbc temp6,temp8
	rcall FUNCTION_DIVISION_32_16
	; Ergebnis grer als PIXEL ?	
	cpi temp2,HIGH(DISPLAY_PIXEL_Y)	; HIGH
	breq TOUCH_BERECHNUNG_KOORDINATEN_Y_L
	brsh TOUCH_BERECHNUNG_KOORDINATEN_Y_ERROR
	brlo TOUCH_BERECHNUNG_KOORDINATEN_Y_OK
TOUCH_BERECHNUNG_KOORDINATEN_Y_L:
	cpi temp1,LOW (DISPLAY_PIXEL_Y)	; LOW 
	breq TOUCH_BERECHNUNG_KOORDINATEN_Y_OK
	brlo TOUCH_BERECHNUNG_KOORDINATEN_Y_OK
TOUCH_BERECHNUNG_KOORDINATEN_Y_ERROR:
	; ERROR						
	ldi temp1,LOW (DISPLAY_PIXEL_Y)
	ldi temp2,HIGH(DISPLAY_PIXEL_Y)
TOUCH_BERECHNUNG_KOORDINATEN_Y_OK:
	; Ergebnis speichern		
	STS(adr_TOUCH_KOORDINATE_Y_L),temp1
	STS(adr_TOUCH_KOORDINATE_Y_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TOUCH_TESTER_A:
	; X auf AUSGANG			
	sbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	sbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	; X LOW					
	cbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	
	; Y auf AUSGANG			
	sbi (TOUCH_YP_DDR),(TOUCH_YP_PIN_NR)	; Y+	
	sbi (TOUCH_YN_DDR),(TOUCH_YN_PIN_NR)	; Y+	
	; Y auf LOW				
	cbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
;-------------------------------------------------------------------------------
	; X auf EINGANG			
	cbi (TOUCH_XP_DDR),(TOUCH_XP_PIN_NR)	; X+	
	cbi (TOUCH_XN_DDR),(TOUCH_XN_PIN_NR)	; X-	
	; Y LOW/HIGH					
	sbi (TOUCH_YP_PORT),(TOUCH_YP_PIN_NR)	; Y+	
	cbi (TOUCH_YN_PORT),(TOUCH_YN_PIN_NR)	; Y-	
	; X PULL-UP ein					
	sbi (TOUCH_XP_PORT),(TOUCH_XP_PIN_NR)	; X+	
	sbi (TOUCH_XN_PORT),(TOUCH_XN_PIN_NR)	; X-	

;-------------------------------------------------------------------------------
TOUCH_TESTER_A_s:
	WDR
	rcall MESSEN_0
	rcall MESSEN_1
	rcall MESSEN_2
	rcall MESSEN_3

	rcall wait_100ms
	rcall ANZEIGE_ADC
	rjmp TOUCH_TESTER_A_s
; ##############################################################################
; ##############################################################################
; ##############################################################################



