;######################################################################## 
;######################################################################## 
;######################################################################## 
TWI_INI:
	; TWI TWCR 				Control-REGISTER	
	ldi temp, 1<<TWINT|1<<TWEA|0<<TWSTA|0<<TWSTO|0<<TWWC|1<<TWEN|1<<TWIE
	out TWCR,temp
	; TWI TWAR (nur SLAVE) 	Adress-Register		
	ldi temp,(TWI_SLAVE_ADRESSE<<TWA0 | TWI_GENERAL_CALL_ENABLE<<TWGCE)
	out TWAR,temp
	; auf EINGANG								
	sbi (TWI_SCL_DDR),(TWI_SCL_PIN_NR)		; SCL	
	sbi (TWI_SDA_DDR),(TWI_SDA_PIN_NR)		; SDA	
	; PULL-UP-EIN								
	sbi (TWI_SCL_PORT),(TWI_SCL_PIN_NR)		; SCL	
	sbi (TWI_SDA_PORT),(TWI_SDA_PIN_NR)		; SDA	
ret
; #############################################################################
; #############################################################################
; #############################################################################
;																				
; TWI INTERRUPPT-Routine														
;																				
TWSI:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR		; GELB an	
	; sichern			
	push TEMP
	in TEMP,SREG	     ; Schreiben von  SREG  im Stack (KOPIE)	
	push temp
	push temp1           ; temp1 auf dem Stack sichern            	
	push ZL
	push ZH
;-------------------------------------------------------------------------------
	in temp, TWSR		; TWI- Status-Register abfragen							
	andi temp, 0xF8		; Bit0...2 ausblenden (Prescaler und Reserve-Bit)		
;-------------------------------------------------------------------------------
TWSI_TWSR_AUSWERTEN:
	cpi temp, TW_SR_SLA_ACK			 	; x60
	breq TWSI_TW_SR_SLA_ACK
	cpi temp, TW_SR_ARB_LOST_SLA_ACK 	; x68
	breq TWSI_TW_SR_ARB_LOST_SLA_ACK
	cpi temp, TW_SR_GCALL_ACK			; x70
	breq TWSI_TW_SR_GCALL_ACK
	cpi temp, TW_SR_ARB_LOST_GCALL_ACK	; x78
	breq TWSI_TW_SR_ARB_LOST_GCALL_ACK
	cpi temp, TW_SR_DATA_ACK      		; x80
	breq TWSI_TW_SR_DATA_ACK      	
	cpi temp, TW_SR_DATA_NACK      		; x88
	breq TWSI_TW_SR_DATA_NACK
	cpi temp, TW_SR_GCALL_DATA_ACK   	; x90
	breq TWSI_TW_SR_GCALL_DATA_ACK   
	cpi temp, TW_SR_GCALL_DATA_NACK		; x98
	breq TWSI_TW_SR_GCALL_DATA_NACK
	cpi temp, TW_SR_STOP        		; xA0
	breq TWSI_TW_SR_STOP        	
	cpi temp, TW_ST_SLA_ACK        		; 0xA8
	breq TWSI_TW_ST_SLA_ACK	
	cpi temp, TW_ST_ARB_LOST_SLA_ACK	; 0xB0
	breq TWSI_TW_ST_ARB_LOST_SLA_ACK
	cpi temp, TW_ST_DATA_ACK      		; 0xB8
	breq TWSI_TW_ST_DATA_ACK
	cpi temp, TW_ST_DATA_NACK      		; 0xC0
	breq TWSI_TW_ST_DATA_NACK
	cpi temp, TW_ST_LAST_DATA      		; 0xC8
	breq TWSI_TW_ST_LAST_DATA 
	cpi temp, TW_NO_INFO        		; 0xF8
	breq TWSI_TW_NO_INFO
	cpi temp, TW_BUS_ERROR        		; 0x00 (Error)
	breq TWSI_TW_BUS_ERROR 
	rjmp TWSI_ANTWORT					; nicht behandelte Status-Zustnde	
;-------------------------------------------------------------------------------
; SLAVE RECEIVER						
TWSI_TW_SR_SLA_ACK:						; x60 ("SLA+W" wurde empfangen) 				
	; START				
	rjmp TWSI_ANTWORT
TWSI_TW_SR_ARB_LOST_SLA_ACK:			; x68 (Arbitration verloren)					
	; NIX tun			
	rjmp TWSI_ANTWORT
TWSI_TW_SR_GCALL_ACK:					; x70 ("General Call" wurde empfangen)			
	; START "General Call"		
	rjmp TWSI_ANTWORT
TWSI_TW_SR_ARB_LOST_GCALL_ACK:			; x78 (Arbitration verloren)					
	; NIX tun			
	rjmp TWSI_ANTWORT
TWSI_TW_SR_DATA_ACK:					; x80 ("SLA+W"-Datenbyte wurden empfangen) 		
	; DATA-RX			
	in temp1, TWDR		
	rcall TWI_SLAVE_DATA_RX_TEMP1
	rjmp TWSI_ANTWORT
TWSI_TW_SR_DATA_NACK:      				; x88 (die vorher adressierten (SLA+W) Daten wurden empfangen; ACK wurde nicht zurckgesedet
	; NIX tun			
	rjmp TWSI_ANTWORT
TWSI_TW_SR_GCALL_DATA_ACK:				; x90 ("General Call"-Datenbyte wurden empfangen)	
	; DATA				
	in temp1, TWDR	; DUMMY		
	rjmp TWSI_ANTWORT
TWSI_TW_SR_GCALL_DATA_NACK:				; x98 (die vorher adressierten (General call) Daten wurden empfangen;  ACK wurde nicht zurckgesendet	
	; NIX tun			
	rjmp TWSI_ANTWORT
TWSI_TW_SR_STOP:						; xA0 (STOP oder Repead-START wurde empfangen)
	; STOP				
	rjmp TWSI_ANTWORT
;-------------------------------------------------------------------------------
;	SLAVE TRANSMITTER					
TWSI_TW_ST_SLA_ACK:						; xA8 (SLA+R wurde empfangen) + ACK 
	; BUFFER auslesen und in den Sendepuffer screiben
	rcall BUFFER_DATA_READ
	; DATA_TX		
	rcall TWI_SLAVE_DATA_TX_TEMP1
	OUT TWDR, temp1						; DATA zur Verfgung stellen
	rjmp TWSI_ANTWORT
TWSI_TW_ST_ARB_LOST_SLA_ACK:			; xB0 (Arbitration verlor SLA+R/W als MASTER, ACK wurde zurckgesendet)	
	rjmp TWSI_ANTWORT
TWSI_TW_ST_DATA_ACK:					; xB8 (DATEN wurden bertragen) + ACK 	
	; DATA-TX			
	rcall TWI_SLAVE_DATA_TX_TEMP1
	OUT TWDR, temp1						; DATA zur Verfgung stellen
	rjmp TWSI_ANTWORT
TWSI_TW_ST_DATA_NACK:					; xC0 (TWDR ist bertragen worden;  ACK ist NICHT empfangen worden
	ldi temp,'C'	
	OUT TWDR, temp						; DATA zur Verfgung stellen
	rjmp TWSI_ANTWORT
TWSI_TW_ST_LAST_DATA:					; xC8 (Letztes Datenbyte in TWDR ist bertragen worden (TWEA = "0");  Ack ist empfangen worden
	ldi temp,'D'
	OUT TWDR, temp						; DATA zur Verfgung stellen
	rjmp TWSI_ANTWORT
	; NO INFO		
TWSI_TW_NO_INFO:						; xF8 (Keine relevanten Zustandinformationen vorhanden;  TWINT = "0" keine TWDR-Ttigkeit 
	rjmp TWSI_ANTWORT
; ERROR									
TWSI_TW_BUS_ERROR:						; x00 (Bus-Error wegen ungltige STARToder STOP BEDIgung; keine TWDR-Ttigkeit 
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
	rjmp TWSI_ANTWORT
;--------------------------------------
TWSI_ANTWORT:	
	; ANTWORTEN							
	ldi temp, 1<<TWINT|1<<TWEA|1<<TWEN|1<<TWIE
	out TWCR,temp
;--------------------------------------
	rcall wait_1ms
	; wider herstellen	
	pop ZH
	pop ZL
	pop temp1
	pop	TEMP						; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP					; Wiederherstellen von SREG
	pop	TEMP						; LESEN von SREG vom STACK (KOPIE)
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR		; GELB aus			
reti
; #############################################################################
; #############################################################################
; #############################################################################
; Die DATEN vom MASTER empfangen											   
;																			   
; INP: temp1 <= DATEN														   
;																			   
TWI_SLAVE_DATA_RX_TEMP1:
	cpi temp1,'B'	; BEEP 		
	breq TWI_SLAVE_DATEN_AUSWERTEN_TEMP1_BEEP
	cpi temp1,'O'	; BEEP on	
	breq TWI_SLAVE_DATEN_AUSWERTEN_TEMP1_BEEP_ON
	cpi temp1,'F'	; BEEP off	
	breq TWI_SLAVE_DATEN_AUSWERTEN_TEMP1_BEEP_OFF
	cpi temp1,'C'	; CLEAR		
	breq TWI_SLAVE_DATEN_AUSWERTEN_TEMP1_CLEAR
	cpi temp1,'R'	; RESET		
	breq TWI_SLAVE_DATEN_AUSWERTEN_TEMP1_RESET
	ret
TWI_SLAVE_DATEN_AUSWERTEN_TEMP1_BEEP:
	cbi (BEEP_PORT)     ,(BEEP_PIN_NR)		    ; BEEP an	
	rcall wait_100ms
	sbi (BEEP_PORT)     ,(BEEP_PIN_NR)		    ; BEEP aus	
	ret
TWI_SLAVE_DATEN_AUSWERTEN_TEMP1_BEEP_ON:
	STS(adr_TOUCH_BEEP_DISABLE),NULL
	ret
TWI_SLAVE_DATEN_AUSWERTEN_TEMP1_BEEP_OFF:
	STS(adr_TOUCH_BEEP_DISABLE),VOLL
	ret
TWI_SLAVE_DATEN_AUSWERTEN_TEMP1_CLEAR:
	rcall BUFFER_CLEAR							; BUFFER CLEAR	
	ret
TWI_SLAVE_DATEN_AUSWERTEN_TEMP1_RESET:
	ldi temp, 1<<TWINT|1<<TWEA|1<<TWEN|1<<TWIE	; ANTWORTEN		
	out TWCR,temp
TWI_SLAVE_DATEN_AUSWERTEN_TEMP1_RESET_s:
	cbi (BEEP_PORT)     ,(BEEP_PIN_NR)		    ; BEEP an		
	rjmp TWI_SLAVE_DATEN_AUSWERTEN_TEMP1_RESET_s; RESET ber WDR
; #############################################################################
; #############################################################################
; #############################################################################
; Die DATEN an MASTER senden												   
;																			   
; OUT: temp1 <= DATEN														   
;																			   
TWI_SLAVE_DATA_TX_TEMP1:
	; berlauf ?
	LDS temp,(adr_TWI_ZEIGER_TX)	; ZEIGER laden		
	cpi temp,255
	brlo TWI_SLAVE_DATA_TX_TEMP1_RUN
	clr temp1
	ret
TWI_SLAVE_DATA_TX_TEMP1_RUN:
	; Z-initialisieren		
	ldi ZL,LOW (adr_TWI_BUFFER_TX_256)
	ldi ZH,HIGH(adr_TWI_BUFFER_TX_256)
	add ZL,temp
	adc ZH,NULL
	inc temp						; +1 
	STS(adr_TWI_ZEIGER_TX),temp		; ZEIGER speichern	
	LD temp1,Z
	ST Z,NULL
ret
; #############################################################################
; #############################################################################
; #############################################################################
