;												
; TOUCH-SCREEN mit ATmega8						
; Bernhard.Erfurt@gmx.de						
; 15.01/2015									
;												
; Bei Bedarf: LCD 2x16 oder 4x16				
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> LCD									
; PB1 ==> LCD									
; PB2 ==> LCD									
; PB3 ==> LCD									
; PB4 ==> LCD R/S								
; PB5 ==> LCD E									
; PB6 ==> (Quarz)								
; PB7 ==> (Quarz)								
;												
; PC0 ==> ADC0(Y+)								
; PC1 ==> ADC1(X+)								
; PC2 ==> ADC2(Y-)								
; PC3 ==> ADC3(Y+)								
; PC4 ==> TWI-DATA								
; PC5 ==> TWI-SCL								
;												
; PD0 ==> 										
; PD1 ==> TX									
; PD2 ==> SBUF (DATEN im Sendepuffer)			
; PD3 ==> 										
; PD4 ==> BEEP									
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"
; TAKT											
.equ TAKT							=1000000	; 1 MHz	
; BAUD											
.equ BAUD							=9600
; SLAVE-ADRESSE									
.equ TWI_SLAVE_ADRESSE				=112
; GENERAL CALL									
.equ TWI_GENERAL_CALL_ENABLE		=0
; TWI Slave Receiver Codes						
.equ TW_SR_SLA_ACK        	= 0x60
.equ TW_SR_ARB_LOST_SLA_ACK = 0x68
.equ TW_SR_GCALL_ACK      	= 0x70
.equ TW_SR_ARB_LOST_GCALL_ACK=0x78
.equ TW_SR_DATA_ACK      	= 0x80
.equ TW_SR_DATA_NACK      	= 0x88
.equ TW_SR_GCALL_DATA_ACK   = 0x90
.equ TW_SR_GCALL_DATA_NACK  = 0x98
.equ TW_SR_STOP        		= 0xA0
; TWI Slave Transmitter Codes					
.equ TW_ST_SLA_ACK        	= 0xA8
.equ TW_ST_ARB_LOST_SLA_ACK = 0xB0
.equ TW_ST_DATA_ACK      	= 0xB8
.equ TW_ST_DATA_NACK      	= 0xC0
.equ TW_ST_LAST_DATA      	= 0xC8
.equ TW_NO_INFO        		= 0xF8
.equ TW_BUS_ERROR        	= 0x00

; DISPLAY PIXEL									
; TV-PROJEKT: 	 320x256						
; LS-7:			1024x600 16:9					
; LS-8:			1024x768  4:3					
.equ DISPLAY_PIXEL_X				=1000
.equ DISPLAY_PIXEL_Y				=1000
; TOUCH											
.equ TOUCH_ENTPRELLZEIT_ANTIPPEN	=10 		;(1=1ms)
.equ TOUCH_ENTPRELLZEIT_LOSLASSEN	=100 		;(1=1ms)
; TOUCH-KORREKTUR								
.equ TOUCH_ADC_KORREKTUR_X_MIN		= 60
.equ TOUCH_ADC_KORREKTUR_X_MAX		=-60
.equ TOUCH_ADC_KORREKTUR_Y_MIN		= 60
.equ TOUCH_ADC_KORREKTUR_Y_MAX		=-60
; TOUCH(Y+)										
.equ TOUCH_YP_PIN_NR				= 0
.equ TOUCH_YP_DDR					= DDRC
.equ TOUCH_YP_PORT					= PORTC
.equ TOUCH_YP_PIN					= PINC
; TOUCH(X+)										
.equ TOUCH_XP_PIN_NR				= 1
.equ TOUCH_XP_DDR					= DDRC
.equ TOUCH_XP_PORT					= PORTC
.equ TOUCH_XP_PIN					= PINC
; TOUCH(Y-)										
.equ TOUCH_YN_PIN_NR				= 2
.equ TOUCH_YN_DDR					= DDRC
.equ TOUCH_YN_PORT					= PORTC
.equ TOUCH_YN_PIN					= PINC
; TOUCH(X-)										
.equ TOUCH_XN_PIN_NR				= 3
.equ TOUCH_XN_DDR					= DDRC
.equ TOUCH_XN_PORT					= PORTC
.equ TOUCH_XN_PIN					= PINC
; TWI-SDA										
.equ TWI_SDA_PIN_NR					= 5
.equ TWI_SDA_DDR					= DDRC
.equ TWI_SDA_PORT					= PORTC
; TWI-SCL										
.equ TWI_SCL_PIN_NR					= 6
.equ TWI_SCL_DDR					= DDRC
.equ TWI_SCL_PORT					= PORTC
; LED-SBUF (DATEN im SENDEPUFFER)				
.equ LED_SBUF_PIN_NR				= 2
.equ LED_SBUF_DDR					= DDRD
.equ LED_SBUF_PORT					= PORTD
; BEEP											
.equ BEEP_PIN_NR					= 4
.equ BEEP_DDR						= DDRD
.equ BEEP_PORT						= PORTD
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD
; LCD (DATA)									
.equ LCD_DATA0_DDR					= DDRB
.equ LCD_DATA1_DDR					= DDRB
.equ LCD_DATA2_DDR					= DDRB
.equ LCD_DATA3_DDR					= DDRB
.equ LCD_DATA0_PORT					= PORTB
.equ LCD_DATA1_PORT					= PORTB
.equ LCD_DATA2_PORT					= PORTB
.equ LCD_DATA3_PORT					= PORTB
.equ LCD_DATA0						= 0
.equ LCD_DATA1						= 1
.equ LCD_DATA2						= 2
.equ LCD_DATA3						= 3
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_DDR						= DDRB
.equ LCD_RS_PORT					= PORTB
.equ LCD_RS							= 4
; LCD_ENABLE									
.equ LCD_EN_DDR						= DDRB
.equ LCD_EN_PORT					= PORTB
.equ LCD_EN							= 5
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=SRAM_START		; 0x0060 START Adresse 		


.equ adr_ERROR_CODE					=SRAM_START+4		; ERROR CODE vom ersten auftretenden Fehler		



.equ adr_ADC_0_L					=SRAM_START+50	; Y+				
.equ adr_ADC_0_H					=SRAM_START+51
.equ adr_ADC_1_L					=SRAM_START+52	; X+				
.equ adr_ADC_1_H					=SRAM_START+53
.equ adr_ADC_2_L					=SRAM_START+54	; Y-				
.equ adr_ADC_2_H					=SRAM_START+55
.equ adr_ADC_3_L					=SRAM_START+56	; X-				
.equ adr_ADC_3_H					=SRAM_START+57

.equ adr_ADC_X_MIN_L				=SRAM_START+60	; physikalisch	
.equ adr_ADC_X_MIN_H				=SRAM_START+61
.equ adr_ADC_X_MAX_L				=SRAM_START+62
.equ adr_ADC_X_MAX_H				=SRAM_START+63
.equ adr_ADC_Y_MIN_L				=SRAM_START+64	; physikalisch	
.equ adr_ADC_Y_MIN_H				=SRAM_START+65
.equ adr_ADC_Y_MAX_L				=SRAM_START+66
.equ adr_ADC_Y_MAX_H				=SRAM_START+67

.equ adr_TWI_ZEIGER_TX				=SRAM_START+200
.equ adr_TWI_BUFFER_TX_256			=SRAM_START+201	; 256 BYTE		


.equ adr_TOUCH_KOORDINATE_X_L		=SRAM_START+500
.equ adr_TOUCH_KOORDINATE_X_H		=SRAM_START+501
.equ adr_TOUCH_KOORDINATE_Y_L		=SRAM_START+502
.equ adr_TOUCH_KOORDINATE_Y_H		=SRAM_START+503
.equ adr_TOUCH_ANZAHL				=SRAM_START+504	; ANZAHL TOUCH	
.equ adr_TOUCH_BEEP_DISABLE			=SRAM_START+505
.equ adr_TOUCH_BUFFER_ZEIGER_WRITE	=SRAM_START+506
.equ adr_TOUCH_BUFFER_ZEIGER_READ	=SRAM_START+507
.equ adr_TOUCH_BUFFER_256			=SRAM_START+508	; 256 BYTE		



.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	
; REGISTER										

.def DUMMY_R0	= R0	; wichtige Hilfsregister (nicht verwenden !)
.def DUMMY_R1	= R1	; wichtige Hilfsregister (nicht verwenden !)

.def NULL 	= R12
.def EINS 	= R14
.def VOLL	= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp TWSI       		; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
	rcall SRAM_CLEAR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
; PORT B+C+D initialisieren								
	out DDRB, NULL
	out DDRC, NULL
	out DDRD, NULL
	out PORTB,NULL
	out PORTC,NULL
	out PORTD,NULL
; LED_INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; BEEP												
	rcall BEEP_LANG
; LED-TEST											
	rcall LED_TEST
; ADC_INITIALISIERUNG								
	rcall ADC_INITIALISIERUNG
; TOUCH_INITIALISIERUNG								
	rcall TOUCH_INITIALISIERUNG
; TOUCH_STANDBY_MODUS								
	rcall TOUCH_STANDBY_MODUS
; USART_INITIALISIEREN								
	rcall USART_INITIALISIEREN
; TWI_INITIALISIEREN								
	rcall TWI_INI
; LCD-INITIALISIERUNG								
	rcall LCD_INITIALISIERUNG
; 	PROGRAMM_CHECK									
	rcall PROGRAMM_CHECK
; ANZEIGE_BEGRUESSUNG								
	rcall ANZEIGE_BEGRUESSUNG
	rcall WAIT_100ms
	rcall WAIT_100ms
	rcall WAIT_100ms
; Interrupts freigeben								
	sei
	rcall ANZEIGE_ERROR_CODE
	rcall ANZEIGE_WAIT
	;rjmp PIN_TESTER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
	; LOOP, bis Y+ gegen GND gezogen wird	
	sbic (TOUCH_YP_PIN),(TOUCH_YP_PIN_NR)
	rjmp LOOP
;-------------------------------------------------------------------------------
	rcall TOUCH_MESSUNG
	rcall ANZEIGE_ERROR_CODE
	rcall PROGRAMM_CHECK
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "TOUCH_TOUCH.asm"				; TOUCH							
.include "TOUCH_ADC.asm"				; ADC							
.include "TOUCH_LCD.asm"				; LCD allgemein					
.include "TOUCH_LCD_ini.asm"			; LCD  Initialisierung 2/4x16/20
.include "TOUCH_BUFFER.asm"				; BUFFER						
.include "TOUCH_USART.asm"				; USART							
.include "TOUCH_SONSTIGES.asm"			; sonstiges						
.include "TOUCH_TWI_SLAVE.asm"			; TWI-SLAVE						
.include "TOUCH_FUNKTIONEN.asm"			; FUNKTIONEN					
.include "TOUCH_WAIT_01MHZ.asm"			;  1 MHz						
;.include "TOUCH_WAIT_08MHZ.asm"		;  8 MHz						
;.include "TOUCH_WAIT_16MHZ.asm"		; 16 MHz						
; ##############################################################################
; ##############################################################################
; ##############################################################################

TEXT_BEGRUESSUNG_1:
.db "ATmega8",0
TEXT_BEGRUESSUNG_2:
.db "TOUCHSCREEN",0
TEXT_BEGRUESSUNG_3:
.db "V1 01/2015 ",0
TEXT_BEGRUESSUNG_4:
.db "TWI + 4-WIRE ",0




